%1/4 car suspension model
%parameters

clear all
close all
syms x v th thdot th2dot vdot wdot s
syms rw mw mc Iw lp mp Ip g
Iw=mw*rw^2;
xp=lp*sin(th)+x;
yp=lp*cos(th);
vxp=diff(xp,th)*thdot+diff(xp,x)*v;
vyp=diff(yp,th)*thdot;
ke=0.5*mp*(vxp^2+vyp^2)+0.5*Ip*thdot^2+0.5*simplify(Iw*(v/rw)^2)+0.5*mc*v^2;
pe=lp*yp*mp*g;
L=ke-pe;
dL1=diff(L,v); dL2=diff(L,thdot);
dL1dot=diff(dL1,thdot)*th2dot+diff(dL1,v)*vdot+diff(dL1,th)*thdot;
dL2dot=diff(dL2,thdot)*th2dot+diff(dL2,v)*vdot+diff(dL2,th)*thdot;
Lth=diff(L,th);
eqm1=simplify(dL1dot);
eqm2=simplify(dL2dot-Lth);
leqm1=subs(eqm1,th,0);
leqm2=subs(eqm2,th,0)+subs(diff(eqm2,th),th,0)*th;
leqm=[leqm1;leqm2];
M=jacobian(leqm,[vdot;th2dot]);
G=[zeros(2,1) diff(leqm,th)];
B=[1;0];
TF=(M*s^2+G)\B;
Mn=subs(M,{mc,mw,mp,lp,Ip},{80,20,80,0.6,80*1.7^2/12});
Gn=subs(G,{mc,mw,mp,lp,Ip,g},{80,20,80,0.6,80*1.7^2/12,10});
Mn=double(Mn); Gn=double(Gn);
TFn=(Mn*s^2+Gn)\B;

%Numerical Computation
A=[0 0 1 0;0 0 0 1;-Mn\Gn zeros(2,2)];
B=[0;0;Mn\[1;0]];
C1=[0 0 1 0];
C2=[0 1 0 0];
D=0;
sysv=ss(A,B,C1,D);
sysp=ss(A,B,C2,D);
[numv,denv]=tfdata(sysv,'v');
[nump,denp]=tfdata(sysp,'v');
numv=(abs(numv)>1e-8).*numv;
denv=(abs(denv)>1e-8).*denv;
nump=(abs(nump)>1e-8).*nump;
denp=(abs(denp)>1e-8).*denp;
sysv=tf(numv,denv);
nump=[nump 0]/numv(2);
numv=numv/numv(2);
sysp=tf(nump,numv);

%Control Design
Kv=1/0.01/numv(2);
sysvc=feedback(Kv*sysv,1);
syso=-minreal(sysvc*sysp);


